PROCEDURE err_proc
******************
PARAMETERS mtxt1, mtxt2, mtxt3
SET INTENSITY OFF
SET TYPEAHEAD TO 0
ACTIVATE WINDOW warning
DO CENTER WITH mtxt1, 60
DO CENTER WITH mtxt2, 60
DO CENTER WITH "Error number "+LTRIM(STR(mtxt3)), 60
STORE INKEY(3) TO mkey
DEACTIVATE WINDOW warning
SET INTENSITY ON
SET TYPEAHEAD TO 20
RETURN


PROCEDURE s_exit
****************
PARAMETERS mexit
SET INTENSITY OFF
SET TYPEAHEAD TO 0
ACTIVATE WINDOW warning
DO CENTER WITH "WARNING!", 60
DO CENTER WITH mexit, 60
STORE INKEY(3) TO mkey
DEACTIVATE WINDOW warning
SET INTENSITY ON
SET TYPEAHEAD TO 10
RETURN


PROCEDURE CENTER
****************
PARAMETERS mtxt,nrow
STORE LEN(mtxt) TO ww
rr = (nrow - ww)/2
? SPACE(rr)+mtxt
RETURN


PROCEDURE  helpinfo
*******************
DEFINE WINDOW info1 FROM 05, 05 TO 19, 74 COLOR GR+/GB, , GR+/GB
DEFINE WINDOW info2 FROM 08, 07 TO 18, 72 NONE COLOR GR+/GB, , GR+/GB
STORE VARREAD() TO item
STORE SPACE(1) TO answer

SELECT SELECT()
USE key_code ORDER f1
ACTIVATE WINDOW info1
DO center WITH "SOTER attribute codes help facility 1.0", 68
ACTIVATE WINDOW info2

IF SEEK(item, "key_code")
   SET HEADING OFF
   SCAN WHILE UPPER(answer) <> "S"
     @ 01, 00 SAY " Code     Description"
     @ 02, 00 SAY "      "
     LIST FIELDS alphacode, descriptio OFF NEXT 5 FOR fieldname = item
     @ 08, 00 SAY ""
     IF fieldname <> item
        WAIT " Press any key to return to input screen..."
        EXIT
     ELSE
        WAIT " press SPACE BAR to continue, S to stop" TO answer
        CLEAR
     ENDIF
   ENDSCAN
   SET HEADING ON 
ELSE
   @ 02, 00 SAY " Sorry, no codes information available on this item."
   @ 07, 00 SAY ""
   WAIT " Press any key to continue..."
ENDIF

USE
DEACTIVATE WINDOW info2
RELEASE WINDOW info2
DEACTIVATE WINDOW info1
RELEASE WINDOW info1
SELECT 1
RETURN


FUNCTION helpitem
*******************
PARAMETERS item, filename, key, header
IF READKEY() = 12    && Process ESC 
   RETURN .T.
ENDIF
STORE SPACE(1) TO answer

IF .NOT. SEEK(item, filename)
   DEFINE WINDOW info1 FROM 05, 20 TO 19, 60 COLOR GR+/GB, , GR+/GB
   DEFINE WINDOW info2 FROM 08, 22 TO 18, 58 NONE COLOR GR+/GB, , GR+/GB
   SET HEADING OFF

   ACTIVATE WINDOW info1
   @ 01, 02 SAY header
   ACTIVATE WINDOW info2
   SELECT &filename
   SCAN ALL WHILE UPPER(answer) <> "S"
     LIST FIELDS &key OFF NEXT 7
     @ 08, 00
     IF EOF()
        WAIT " Press any key to return..."
        EXIT
     ELSE
        WAIT " SPACE BAR = continue, S = stop" TO answer
        CLEAR
     ENDIF
   ENDSCAN

   SET HEADING ON 
   DEACTIVATE WINDOW info2
   RELEASE WINDOW info2
   DEACTIVATE WINDOW info1
   RELEASE WINDOW info1
   SELECT 1
   RETURN .F.
ENDIF

RETURN .T.
